.TH PERFMON 1 "Release 4" "XVersion 11"
.SH NAME
perfmon - local perfmormance meter
.SH SYNOPSIS
.B "perfmon"
[-help] [-help-resources] [-display <displayname>] 
[-geometry <geometryspecification>]
[-update <hundredths of a second>] [-nolabel] [-format <formatstring>]
[-(cpu | disk | packets | pageing | swapping | interrupts | context | load | 
collisions | errors | forks)]

Format String:
    %m  Current Maximum
    %n  Name of statistic monitered
    %h  Full hostname
    %Hx Hostname truncated to x periods. [0-9]

.SH DESCRIPTION
.PP
.B perfmon
displays various types of information about the current performance
of the machine that you are using.  It does this by reading the 
statistics in from the kernel.
.SH OPTIONS
.TP 8
.B \-help
Displays the help message, which is essentially the synopsis.
.TP 8
.B \-help-resources
Lists all of the resources which are referenced.  You need to be able to
connect to an X server for this to work.
.TP 8
.B \-display
Specifies which display the program should display on.  Generally 
this is hostname:0 
.TP 8
.B \-geometry
Specifies the geometry the the program should use.  This is a string of 
the format : [=][<width>x<height>][{+-}xoffset{+-}yoffset]  For example
to get the program to display in the lower right hand corner with a size
of 200 pixels by 100 pixels you would type 
.B perfmon -geometry 200x100-0-0
.TP 8
.B \-update <hundredths of a second>
Specifies how often the update should be run.  Values under .1 seconds
i.e. a value of 10 are likely to be meaningless.  Defaults to 100, or 
one update a second.
.TP 8
.B \-nolabel
Removes the label from the display.
.TP 8
.B \-format <formatstring>
Specifies the format for the label to be in.  This option is meaningless 
if the label is not displayed.  The valid format specifiers are %m, which
is the current maximum.  %n which is the name of the statistic being 
monitered.  %h will give the full hostname that the program is run on, and
%Hx where x is in [0-9] will give the Hostname truncated to x periods.
For example if your machinename was euterpe.weh.andrew.cmu.edu, %H2 would
cause only the euterpe.weh to be displayed.  Finally, %% will cause a single
percent(%) character to be added. The format defaults to "%n %m %h".
.TP 8

.B \-<types>
Specifies the statistic to monitor.  Options are: cpu, disk, packets, paging,
swapping, interrupts, context, load, collisions, errors, forks.
 cpu monitors the 
total cpu being used
disk monitors the total of the input and output blocks.  packets measures
the number of packets travelling both in and out on all interfaces. 
paging monitors the amount of paging both in and out.  swapping monitors
the swapping in and out.  interrupts measures the number of interrupts
that occur.  context is the number of context switches, and load is the
load that the machine is under. Collisions is the number of collisions
generated by your machine on the ethernet interface, and errors is the 
number of errors on the ethernet interface.  Forks is the number of forks
(normal/vfork) on the machine. Defaults to cpu.

.PP
.SH RESOURCES
.PP
Type perfmon -help-resources to get a list of resources used.

.SH FEATURES
The cpu option will sometimes cause a crash when things haven't changed enough
this will be fixed in the future.

Perfmon has to read /dev/kmem, and therefore may need to be setgid kmem.

.SH COPYRIGHT
It's not my fault, or my employers fault.

.SH AUTHORS
Eric Anderson, Jeffrey Hutzleman

.SH "See ALSO"
X(1), Xserver(1), Xload(1)

